//FarbeErsetzen_403d.js
// 04.12.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Zugewiesene Farbe durch andere ersetzen

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prfen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// sicherstellen, dass keine Musterseite angezeigt ist
if (app.activeWindow.activeSpread.constructor.name == "MasterSpread") {
	alert ("Funktioniert nicht mit Mustervorlagen.", "Stop");
	exit();
}

// die Version speichern
var appVers = (app.version[0])*1;

// die Namen der fixen Farbfelder definieren
noColor    = "[None]";
regisColor = "[Registration]";
paperColor = "[Paper]";
blackColor = "[Black]";

// die Sprache des Programms speichern
var curLang = (app.locale)*1;

// die Namen der Farbfelder vorbereiten (in FR and DE)
if (curLang   == 1279477362) { // = Franzsisch
	noColor      = "[Sans]";
	regisColor   = "[Reprage]";
	paperColor   = "[Papier]";
	blackColor   = "[Noir]";
	if (appVers == 4) {
		noColor    = "[Aucun]";
	}
}
else if (curLang == 1279477613) { // = Deutsch
	noColor      = "[Ohne]";
	regisColor   = "[Passermarken]";
	paperColor   = "[Papier]";
	blackColor   = "[Schwarz]";
	if (appVers == 4) {
		noColor    = "[Keine]";
		regisColor = "[Passkreuze]";
	}
}
// das Dokument im Vordergrund
var curDoc = app.documents[0];

// die Farbfelder des Dokuments
allSwatches = curDoc.swatches;

// eine eventuelle Auswahl prfen und den Farbfeldnamen speichern 
var curSel = false;
var oColor = "";
if (app.selection.length != 0) {
	try {
		if (app.selection[0].constructor.name != "GraphicLine") {
			oColor = app.selection[0].fillColor.name;
		}
		else {
			oColor = app.selection[0].strokeColor.name;;
		}
	}
	catch (e) {
	}
	curSel = true;
}

// die Checkboxenwerte vorbereiten
ck00 = ck01 = ck02 = ck03 = ck04 = ck05 = ck06 = ck07 = ck08 = ck09 = ck10 = ck11 = 0;

// prfen, ob Abschnitts-Prfizes definiert sind
sectPrefs = false;
var allPrefNames = new Array();
for (var p=0; p<curDoc.pages.length; p++) {
	var curSect = curDoc.pages[p].appliedSection.name;
	allPrefNames.push(curSect);
}
var testString = allPrefNames.join("");
if (testString.length > 0) {
	sectPrefs = true;
}
// die Liste der Seitennummern
if (sectPrefs == false) {
	allPageNames = curDoc.pages.everyItem().name;
}
else {
	var allPageNames = new Array();
	for (var p=0; p<curDoc.pages.length; p++) {
		var curName = curDoc.pages[p].name;
		allPageNames.push(allPrefNames[p] + curName);
	}
}

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	if (curSel == true && oColor != "") {
		oName = oColor;
	}
	else {
		var oName = prefVal[0];
	}
	var nName = prefVal[1];
	pNme = prefVal[2];
	if (curSel == false) {
		if (sectPrefs == false) {
			var okay = rangeNoSectPref(pNme, true);
		}
		else {
			var okay = rangeWithSectPref(pNme, true);
		}
		if (okay == false || okay == undefined) {
			pNme = allPageNames[0];
		}
	}
	else {
		if (sectPrefs == false) {
			try {
				pNme = app.selection[0].parentPage.name;
			}
			catch (e) {
				pNme = allPageNames[0];
			}
		}
		else {
			curSect = app.activeWindow.activePage.appliedSection.name;
			pNme = curSect + app.activeWindow.activePage.name;
		}
	}
	var cb00 = prefVal[3];
	if (cb00 == "true") { ck00 = 1; }
	var cb01 = prefVal[4];
	if (cb01 == "true") { ck01 = 1; }
	var cb02 = prefVal[5];
	if (cb02 == "true") { ck02 = 1; }
	var cb03 = prefVal[6];
	if (cb03 == "true") { ck03 = 1; }
	var cb04 = prefVal[7];
	if (cb04 == "true") { ck04 = 1; }
	var cb05 = prefVal[8];
	if (cb05 == "true") { ck05 = 1; }
	var cb06 = prefVal[9];
	if (cb06 == "true") { ck06 = 1; }
	var cb07 = prefVal[10];
	if (cb07 == "true") { ck07 = 1; }
	var cb08 = prefVal[11];
	if (cb08 == "true") { ck08 = 1; }
	var cb09 = prefVal[12];
	if (cb09 == "true") { ck09 = 1; }
	var cb10 = prefVal[13];
	if (cb10 == "true") { ck10 = 1; }
	var cb11 = prefVal[14];
	if (cb11 == "true") { ck11 = 1; }
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde
	// dann auf die Vorgabenwerte zurckgreifen
	ck00 = 1;
	ck01 = 1;
	ck02 = 0;
	ck03 = 1;
	ck04 = 1;
	ck05 = 1;
	ck06 = 1;
	ck07 = 0;
	ck08 = 0;
	ck09 = 0;
	ck10 = 0;
	ck11 = 0;
	if (curSel == true && oColor != "") {
		oName = oColor;
	}
	else {
		oName = blackColor;
	}
	nName = blackColor;
	if (curSel == false) {
		pNme = allPageNames[0];
	}
	else {
		if (sectPrefs == false) {
			try {
				pNme = app.selection[0].parentPage.name;
			}
			catch (e) {
				pNme = allPageNames[0];
			}
		}
		else {
			curSect = app.activeWindow.activePage.appliedSection.name;
			pNme = curSect + app.activeWindow.activePage.name;
		}
	}
}

// die Funktionen aufrufen, welche die Listen der Farben vorbereiten
var oldColor = getColorList(oName);
var oldCol   = oldColor[0];
var oldInd   = oldColor[1];
var newColor = getColorList(nName);
var newCol   = newColor[0];
var newInd   = newColor[1];

// die Funktion aufrufen, welche den Dialog zeigt und auswertet
var anArray = displayDialog();
var oColor  = anArray[0];
var nColor  = anArray[1];
var pNme    = anArray[2];
var ck00    = anArray[3];
var ck01    = anArray[4];
var ck02    = anArray[5];
var ck03    = anArray[6];
var ck04    = anArray[7];
var ck05    = anArray[8];
var ck06    = anArray[9];
var ck07    = anArray[10];
var ck08    = anArray[11];
var ck09    = anArray[12];
var ck10    = anArray[13];
var ck11    = anArray[14];

// die gewhlten Farbfelder vergleichen
if (oColor == nColor) {
	alert ("Alte und neue Farbe sind identisch.", "Stop");
	exit();
}

// die Eingabe prfen lassen
if (sectPrefs == false) {
	allPages = rangeNoSectPref(pNme, false);
}
else {
	allPages = rangeWithSectPref(pNme, false);
}	

// das Auffrischen abstellen
app.scriptPreferences.enableRedraw = false;

// eine Schleife durch die Seiten
for (var p=0; p<allPages.length; p++) {
	// die Funktion aufrufen, welche den Austausch der Farben vornimmt
	changeColor(oColor, nColor, allPages[p]);
}

// das Auffrischen wieder einschalten
app.scriptPreferences.enableRedraw = true;

// das Ende der Aktion verknden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(999);
// das Fenster schliessen
dlog.close();


////////////////////////////// die Funktionen  ////////////////////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet /////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/FarbeErsetzen403.txt");
	}
	else {
		var f = new File("~/Library/Preferences/FarbeErsetzen403.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// die Funktion, welche die Liste der Farben vorbereitet //////////////////////////////////////////
function getColorList(xName) {
	// prfen, ob die Vorgabefarbe existiert
	try {
		curDoc.swatches.itemByName(xName).name;
	}
	catch (e) {
		xName = "Black";
	}
	// die Liste der Farben zusammenstellen;
	// "None", "Paper", "Black" und "Registration" umbenennen;
	// die Position der Vorgabefarbe feststellen
	var xColorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (xName == cName) {
			xIndex = i;
		}
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		xColorList.push(cName);
	}
	return [xColorList, xIndex];
}

// den Dialog vorbereiten und anzeigen ////////////////////////////////////////////////////////////
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth =  70;
	var fieldWidth = 236;
	var aDialog = app.dialogs.add({name:"FarbeErsetzen"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Zugewiesenes Farbfeld ...", minWidth:labelWidth-10});
						staticTexts.add({staticLabel:" "});
					}
					var oldColor = dropdowns.add({stringList:oldCol, selectedIndex:oldInd, minWidth:130});
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"... mit diesem ersetzen", minWidth:labelWidth-10});
						staticTexts.add({staticLabel:" "});
					}
					var newColor = dropdowns.add({stringList:newCol, selectedIndex:newInd, minWidth:130});
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Seitenbereich(e) (z.B. 3-4, 6-9):"});
				staticTexts.add({staticLabel:" ", minWidth:10});
			}
			with (dialogRows.add()) {
				var pagesField = textEditboxes.add({editContents:pNme, minWidth:fieldWidth});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Folgende Objekte behandeln:"});
				staticTexts.add({staticLabel:" ", minWidth:10});
			}
			with (dialogRows.add()) {
				var checkbox00 = checkboxControls.add({staticLabel:"Fllung", checkedState:ck00, minWidth:84});
				var checkbox01 = checkboxControls.add({staticLabel:"Kontur", checkedState:ck01, minWidth:84});
				var checkbox02 = checkboxControls.add({staticLabel:"Lcke", checkedState:ck02});
			}
			with (dialogRows.add()) {
				var checkbox03 = checkboxControls.add({staticLabel:"Bildrahmen", checkedState:ck03, minWidth:130});
				var checkbox04 = checkboxControls.add({staticLabel:"Textrahmen", checkedState:ck04});
			}
			with (dialogRows.add()) {
				var checkbox05 = checkboxControls.add({staticLabel:"Grafikrahmen", checkedState:ck05, minWidth:130});
				var checkbox06 = checkboxControls.add({staticLabel:"Linienrahmen", checkedState:ck06});
			}
			with (dialogRows.add()) {
				var checkbox07 = checkboxControls.add({staticLabel:"Tabellen", checkedState:ck07, minWidth:130});
				var checkbox08 = checkboxControls.add({staticLabel:"Texte", checkedState:ck08});
			}
			with (dialogRows.add()) {
				var checkbox09 = checkboxControls.add({staticLabel:"Absatzlinien", checkedState:ck09, minWidth:130});
				var checkbox10 = checkboxControls.add({staticLabel:"Unterstreichungen", checkedState:ck10});
			}
			with (dialogRows.add()) {
				var checkbox11 = checkboxControls.add({staticLabel:"Effekte (Schlagschatten usw.)", checkedState:ck11});
			}
		}
	}
	if(aDialog.show() == true) {
		oldIndex = oldColor.selectedIndex;
		oColor   = curDoc.swatches[oldIndex].name;
		if      (oColor == blackColor) { oColor = "Black"; }
		else if (oColor == paperColor) { oColor = "Paper"; }
		else if (oColor == regisColor) { oColor = "Registration"; }
		else if (oColor == noColor)    { oColor = "None"; }
		newIndex = newColor.selectedIndex;
		nColor   = curDoc.swatches[newIndex].name;
		if      (nColor == blackColor) { nColor = "Black"; }
		else if (nColor == paperColor) { nColor = "Paper"; }
		else if (nColor == regisColor) { nColor = "Registration"; }
		else if (nColor == noColor)    { nColor = "None"; }
		pNme = pagesField.editContents;
		cb00 = checkbox00.checkedState;
		cb01 = checkbox01.checkedState;
		cb02 = checkbox02.checkedState;
		cb03 = checkbox03.checkedState;
		cb04 = checkbox04.checkedState;
		cb05 = checkbox05.checkedState;
		cb06 = checkbox06.checkedState;
		cb07 = checkbox07.checkedState;
		cb08 = checkbox08.checkedState;
		cb09 = checkbox09.checkedState;
		cb10 = checkbox10.checkedState;
		cb11 = checkbox11.checkedState;
		aDialog.destroy();
		var prefsList = new Array (oColor, nColor, pNme, cb00, cb01, cb02, cb03, cb04, cb05, cb06, cb07, cb08, cb09, cb10, cb11);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		if (pNme == "") {
			alert ("Seitenbereich(e): Das Eingabefeld ist leer.", "Stop");
			exit();
		}
		return [oColor, nColor, pNme, cb00, cb01, cb02, cb03, cb04, cb05, cb06, cb07, cb08, cb09, cb10, cb11];
	}
	else{
		aDialog.destroy();
		exit();
	}
}

// das Ergebnis in eine Datei schreiben ///////////////////////////////////////////////////////////
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/FarbeErsetzen403.txt");
	}
	else {
		var f = File("~/Library/Preferences/FarbeErsetzen403.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// die Liste der Seitenzahlen aufstellen und prfen ///////////////////////////////////////////////
function rangeNoSectPref(pageRange, pre) {  // wenn keine Abschnittsprfizes definiert sind ///////
	var whatKind = 0;
	var pagesList = new Array();
	var indList   = new Array();
	// Leerschlge entfernen
	var newRange = pageRange.split(" ");
	newRange = newRange.join("");
	// prfen, ob Kommas und/oder Bindestriche und/oder Pluszeichen enthalten sind
	if (newRange.indexOf("-") != -1) {
		whatKind = whatKind + 1;
	}
	if (newRange.indexOf(",") != -1) {
		whatKind = whatKind + 2;
	}
	if (newRange.indexOf("+") != -1) {
		whatKind = whatKind + 4;
	}
	// je nach Art der Kette die Listen erstellen
	if (whatKind == 0) {
		pagesList.push(newRange);
	}
	else if (whatKind == 1) {
		var newRangeList = newRange.split("-");
		var startVal = newRangeList[0]*1;
		var stopVal  = (newRangeList[1]*1);
		if (startVal<stopVal) {
			for (var i=startVal; i<stopVal+1; i++) {
				pagesList.push(""+i);
			}
		}
		else {
			for (var i=stopVal; i<startVal+1; i++) {
				pagesList.push(""+i);
			}
		}
	}
	else if (whatKind == 2) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			pagesList.push(newRangeList[i]);
		}
	}
	else if (whatKind == 3) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = tmpItemList[0]*1;
				var stopVal  = (tmpItemList[1]*1);
				if (startVal<stopVal) {
					for (var k=startVal; k<stopVal+1; k++) {
						pagesList.push(""+k);
					}
				}
				else {
					for (var k=stopVal; k<startVal+1; k++) {
						pagesList.push(""+k);
					}
				}
			}
			else {
				pagesList.push(newRangeList[i]);
			}
		}
	}
	else if (whatKind == 4) {
		indList.push((newRange*1)-1);
	}
	else if (whatKind == 5) {
		var newRangeList = newRange.split("-");
		var startVal = (newRangeList[0]*1);
		var stopVal  = (newRangeList[1]*1);
		if (startVal<stopVal) {
			for (var i=startVal-1; i<stopVal; i++) {
				indList.push(i);
			}
		}
		else {
			for (var i=stopVal-1; i<startVal; i++) {
				indList.push(i);
			}
		}
	}
	else if (whatKind == 6) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			if (newRangeList[i][0] == "+") {
				indList.push((newRangeList[i]*1)-1);
			}
			else {
				var okay = false;
				for (var k=0; k<allPageNames.length; k++) {
					if (newRangeList[i] == allPageNames[k]) {
						indList.push(k);
						okay = true;
						break;
					}
				}
				if (!okay) {
					if (pre) {
						return false;
					}
					else {
						alert ("Die Seite " + newRangeList[i] + " ist nicht vorhanden.", "Stop");
						exit();
					}
				}
			}
		}
	}
	else if (whatKind == 7) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = (tmpItemList[0]*1);
				var stopVal  = (tmpItemList[1]*1);
				if (startVal<stopVal) {
					for (var k=startVal-1; k<stopVal; k++) {
						indList.push(k);
					}
				}
				else {
					for (var k=stopVal-1; k<startVal; k++) {
						indList.push(k);
					}
				}
			}
			else {
				if (newRangeList[i][0] == "+") {
					indList.push((newRangeList[i]*1)-1);
				}
				else {
					var okay = false;
					for (var k=0; k<allPageNames.length; k++) {
						if (newRangeList[i] == allPageNames[k]) {
							indList.push(k);
							okay = true;
							break;
						}
					}
					if (!okay) {
						if (pre) {
							return false;
						}
						else {
							alert ("Die Seite " + newRangeList[i] + " ist nicht vorhanden.", "Stop");
							exit();
						}
					}
				}
			}
		}
	}
	// prfen, ob die gewnschten Seiten existieren
	if (whatKind < 4) {
		var nNum = pagesList.length;
		for (var i=0; i<nNum; i++) {
			var okay = false;
			var actNum = pagesList[i];
			for (var k=0; k<allPageNames.length; k++) {
				if (actNum == allPageNames[k]) {
					okay = true;
					indList.push(k);
					break;
				}
			}
		}
		if (okay) {
			if (pre) {
				return true;
			}
			else {
				return indList;
			}
		}
		else {
			if (pre) {
				return false;
			}
			else {
				alert ("Die Seite " + actNum + " ist nicht vorhanden.", "Stop");
				exit();
			}
		}
	}
	else {
		var maxInd = (allPageNames.length)-1;
		for (var i=0; i<indList.length; i++) {
			if (indList[i] > maxInd) {
				if (pre) {
					return false;
				}
				else {
					alert ("Die Seite +" + (indList[i]+1) + " ist nicht vorhanden.", "Stop");
					exit();
				}
			}
		}
	}
	if (pre) {
		return true;
	}
	else {
		return indList;
	}
}

function rangeWithSectPref(pageRange, pre) {  // wenn Abschnittsprfizes definiert sind ///////////
	var preVal = true;
	var whatKind = 0;
	var indList  = new Array();
	// Leerschlge entfernen
	var newRange = pageRange.split(" ");
	newRange = newRange.join("");
	// prfen, ob Kommas und/oder Bindestriche und/oder Pluszeichen enthalten sind
	if (newRange.indexOf("-") != -1) {
		whatKind = whatKind + 1;
	}
	if (newRange.indexOf(",") != -1) {
		whatKind = whatKind + 2;
	}
	if (newRange.indexOf("+") != -1) {
		whatKind = whatKind + 4;
	}
	// je nach Art der Kette die Liste(n) der Seiten erstellen
	if (whatKind == 0) {
		var startVal  = -1;
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == newRange) {
				startVal = n;
				break;
			}
		}
		if (startVal != -1) {
			indList.push(n);
		}
		else {
			if (pre) {
				preVal = false;
			}
			else {
				alert ("Die Seite " + newRange + " existiert nicht.", "Stop");
				exit();
			}
		}
	}
	else if (whatKind == 1) {
		var startVal = -1;
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == newRange) {
				startVal = n;
				break;
			}
		}
		if (startVal != -1) {
			if (pre) {
				preVal = true;
			}
			else {
				indList.push(n);
			}
		}
		else {
			var newRangeList = newRange.split("-");
			if (newRangeList.length == 2) {
				var startPage = newRangeList[0];
				var stopPage  = newRangeList[1];
			}
			else if (newRangeList.length == 3) {
				var startVal  = -1;
				var startPage = newRangeList[0];
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == startPage) {
						startVal = n;
						break;
					}
				}
				if (startVal != -1) {
					var stopPage  = newRangeList[1]+"-"+newRangeList[2];
				}
				else {
					var startPage = newRangeList[0]+"-"+newRangeList[1];
					var stopPage  = newRangeList[2];
				}
			}
			else if (newRangeList.length == 4) {
				var startPage = newRangeList[0]+"-"+newRangeList[1];
				var stopPage  = newRangeList[2]+"-"+newRangeList[3];
			}
			var startVal  = -1;
			var stopVal   = -1;
			for (var n=0; n<allPageNames.length; n++) {
				if (allPageNames[n] == startPage) {
					startVal = n;
					break;
				}
			}
			for (var n=0; n<allPageNames.length; n++) {
				if (allPageNames[n] == stopPage) {
					stopVal = n;
					break;
				}
			}
			if (startVal == -1) {
				if (pre) {
					preVal = false;
				}
				else {
					alert ("Die Seite " + startPage + " existiert nicht.", "Stop");
					exit();
				}
			}
			if (stopVal == -1) {
				if (pre) {
					preVal = false;
				}
				else {
					alert ("Die Seite " + stopPage + " existiert nicht.", "Stop");
					exit();
				}
			}
			if (startVal<stopVal) {
				for (var i=startVal; i<stopVal+1; i++) {
					indList.push(i);
				}
			}
			else {
				for (var i=stopVal; i<startVal+1; i++) {
					indList.push(i);
				}
			}
		}
	}
	else if (whatKind == 2) {
		var newRangeList = newRange.split(",");
		var startPage = newRangeList[0];
		var stopPage  = newRangeList[1];
		var startVal  = -1;
		var stopVal   = -1;
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == startPage) {
				startVal = n;
				indList.push(n);
				break;
			}
		}
		for (var n=0; n<allPageNames.length; n++) {
			if (allPageNames[n] == stopPage) {
				stopVal = n;
				indList.push(n);
				break;
			}
		}
		if (startVal == -1) {
			if (pre) {
				preVal = false;
			}
			else {
				alert ("Die Seite " + startPage + " existiert nicht.", "Stop");
				exit();
			}
		}
		if (stopVal == -1) {
			if (pre) {
				preVal = false;
			}
			else {
				alert ("Die Seite " + stopPage + " existiert nicht.", "Stop");
				exit();
			}
		}
	}
	else if (whatKind == 3) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var startVal = -1;
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == tmpItem) {
						startVal = n;
						break;
					}
				}
				if (startVal != -1) {
					startPage = tmpItem;
					stopPage  = tmpItem;
				}
				else {
					var tmpList = tmpItem.split("-");
					if (tmpList.length == 2) {
						var startPage = tmpList[0];
						var stopPage  = tmpList[1];
					}
					else if (tmpList.length == 3) {
						var startVal  = -1;
						var startPage = tmpList[0];
						for (var n=0; n<allPageNames.length; n++) {
							if (allPageNames[n] == startPage) {
								startVal = n;
								break;
							}
						}
						if (startVal != -1) {
							var stopPage  = tmpList[1]+"-"+tmpList[2];
						}
						else {
							var startPage = tmpList[0]+"-"+tmpList[1];
							var stopPage  = tmpList[2];
						}
					}
					else if (tmpList.length == 4) {
						var startPage = tmpList[0]+"-"+tmpList[1];
						var stopPage  = tmpList[2]+"-"+tmpList[3];
					}
				}
				var startVal  = -1;
				var stopVal   = -1;
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == startPage) {
						startVal = n;
						break;
					}
				}
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == stopPage) {
						stopVal = n;
						break;
					}
				}
				if (startVal == -1) {
					if (pre) {
						preVal = false;
					}
					else {
						alert ("Die Seite " + startPage + " existiert nicht.", "Stop");
						exit();
					}
				}
				if (stopVal == -1) {
					if (pre) {
						preVal = false;
					}
					else {
						alert ("Die Seite " + stopPage + " existiert nicht.", "Stop");
						exit();
					}
				}
				if (startVal<stopVal) {
					for (var k=startVal; k<stopVal+1; k++) {
						indList.push(k);
					}
				}
				else {
					for (var k=stopVal; k<startVal+1; k++) {
						indList.push(k);
					}
				}
			}
			else {
				var startPage = newRangeList[i];
				var startVal  = -1;
				for (var n=0; n<allPageNames.length; n++) {
					if (allPageNames[n] == startPage) {
						startVal = n;
						break;
					}
				}
				if (startVal != -1) {
					indList.push(n);
				}
				else {
					if (pre) {
						preVal = false;
					}
					else {
						alert ("Die Seite " + startPage + " existiert nicht.", "Stop");
						exit();
					}
				}
			}
		}
	}
	else if (whatKind == 4) {
		indList.push((newRange*1)-1);
	}
	else if (whatKind == 5) {
		var newRangeList = newRange.split("-");
		var startVal = (newRangeList[0]*1);
		var stopVal  = (newRangeList[1]*1);
		if (startVal<stopVal) {
			for (var i=startVal-1; i<stopVal; i++) {
				indList.push(i);
			}
		}
		else {
			for (var i=stopVal-1; i<startVal; i++) {
				indList.push(i);
			}
		}
	}
	else if (whatKind == 6) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			if (newRangeList[i][0] == "+") {
				indList.push((newRangeList[i]*1)-1);
			}
			else {
				var okay = false;
				for (var k=0; k<allPageNames.length; k++) {
					if (newRangeList[i] == allPageNames[k]) {
						indList.push(k);
						okay = true;
						break;
					}
				}
				if (!okay) {
					if (pre) {
						return false;
					}
					else {
						alert ("Die Seite " + newRangeList[i] + " ist nicht vorhanden.", "Stop");
						exit();
					}
				}
			}
		}
	}
	else if (whatKind == 7) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = (tmpItemList[0]*1);
				var stopVal  = (tmpItemList[1]*1);
				if (startVal<stopVal) {
					for (var k=startVal-1; k<stopVal; k++) {
						indList.push(k);
					}
				}
				else {
					for (var k=stopVal-1; k<startVal; k++) {
						indList.push(k);
					}
				}
			}
			else {
				if (newRangeList[i][0] == "+") {
					indList.push((newRangeList[i]*1)-1);
				}
				else {
					var okay = false;
					for (var k=0; k<allPageNames.length; k++) {
						if (newRangeList[i] == allPageNames[k]) {
							indList.push(k);
							okay = true;
							break;
						}
					}
					if (!okay) {
						if (pre) {
							return false;
						}
						else {
							alert ("Die Seite " + newRangeList[i] + " ist nicht vorhanden.", "Stop");
							exit();
						}
					}
				}
			}
		}
	}
	// prfen, ob die gewnschten Seiten existieren
	if (whatKind > 3) {
		var maxInd = (allPageNames.length)-1;
		for (var i=indList.length-1; i>-1; i--) {
			if (indList[i] > maxInd) {
				if (pre) {
					return false;
				}
				else {
					alert ("Die Seite +" + (indList[i]+1) + " ist nicht vorhanden.", "Stop");
					exit();
				}
			}
		}
	}
	if (pre) {
		return preVal;
	}
	else {
		return indList;
	}
}

// die Funktion, welche die Farbzuweisung ndert //////////////////////////////////////////////////
function changeColor(oColor, nColor, pNme){
	// alle Objekte der Seite
	var allFrames = curDoc.pages[pNme].allPageItems.slice(0);
	// das aktuelle Farbfeld
	var curSwatch = curDoc.swatches.itemByName(nColor);
	// eine Schleife durch die Objekte
	for (var f=0; f<allFrames.length; f++) {
		// eine Einmal-Schleife (wird verlassen wenn Gruppe oder Bild)
		for (var once=0; once<1; once++) {
			// die Art des Objekts
			var curType = allFrames[f].constructor.name;
			if (curType == "Group") {
				break;
			}
			// der Inhaltstyp des Objekts
			try {
				var curCont = allFrames[f].contentType;
			}
			catch (e) {
				break;
			}
			// wenn "Text", dann prfen, ob das Objekt Text auf einem Pfad enthlt
			if (ck08) {
				var curTxtPath = allFrames[f].textPaths[0];
				try {
					if (curTxtPath.texts[0].texts[0].insertionPoints[0].fillColor.name == oColor) {
						curTxtPath.texts[0].texts[0].insertionPoints[0].fillColor = curSwatch;
					}
					curTxtPath.texts[0].contents;
					var curText = curTxtPath.texts[0];
					var allRanges = curText.textStyleRanges;
					// eine Schleife durch die 'text style ranges'
					for (var r=0; r<allRanges.length; r++) {
						// Fllfarbe
						if (ck00) {
							if (allRanges[r].fillColor.name == oColor) {
								allRanges[r].fillColor = curSwatch;
							}
						}
						// Konturfarbe
						if (ck01) {
							if (allRanges[r].strokeColor.name == oColor) {
								allRanges[r].strokeColor = curSwatch;
							}
						}
						// Unterstreichung
						if (ck10) {
							if (allRanges[r].underlineColor.name == oColor) {
								allRanges[r].underlineColor = curSwatch;
							}
							if (ck02) { // Unterstreichung / Lcke
								if (allRanges[r].underlineGapColor.name == oColor) {
									allRanges[r].underlineGapColor = curSwatch;
								}
							}
						}
					}
					if (ck09) {
						var allParas = curText.paragraphs;
						// eine Schleife durch die Abstze
						for (var s=0; s<allParas.length; s++) {
							// Absatzlinie oben und unten 
							replaceRule(allParas[s], oColor, curSwatch);
							// Absatzlinien-Lcke oben und unten
							replaceRuleGap(allParas[s], oColor, curSwatch);
						}
					}
				}
				catch (e) {
				}
			}
			// die Textrahmen
			if (curCont == ContentType.TEXT_TYPE) {
				// Hintergrundfarbe
				if (ck04) {
					if (ck00) {
						replaceFill(allFrames[f], oColor, curSwatch);
					}
					// Konturfarbe
					if (ck01) {
						replaceStroke(allFrames[f], oColor, curSwatch);
					}
					// Farbe fr Lcke
					if (ck02) {
						replaceGap(allFrames[f], oColor, curSwatch);
					}
				}
				var curText = allFrames[f].texts[0];
				if (ck08) {
					if (allFrames[f].texts[0].insertionPoints[0].fillColor.name == oColor) {
						allFrames[f].texts[0].insertionPoints[0].fillColor = curSwatch;
					}
					var allRanges = curText.textStyleRanges;
					// eine Schleife durch die 'text style ranges'
					for (var r=0; r<allRanges.length; r++) {
						// Fllfarbe
						if (ck00) {
							if (allRanges[r].fillColor.name == oColor) {
								allRanges[r].fillColor = curSwatch;
							}
						}
						// Konturfarbe
						if (ck01) {
							if (allRanges[r].strokeColor.name == oColor) {
								allRanges[r].strokeColor = curSwatch;
							}
						}
						// Unterstreichung
						if (ck10) {
							if (allRanges[r].underlineColor.name == oColor) {
								allRanges[r].underlineColor = curSwatch;
							}
							if (ck02) { // Unterstreichung / Lcke
								if (allRanges[r].underlineGapColor.name == oColor) {
									allRanges[r].underlineGapColor = curSwatch;
								}
							}
						}
					}
				}
				if (ck09) {
					var allParas = curText.paragraphs;
					// eine Schleife durch die Abstze
					for (var s=0; s<allParas.length; s++) {
						// Absatzlinie oben und unten 
						replaceRule(allParas[s], oColor, curSwatch);
						// Absatzlinien-Lcke oben und unten
						replaceRuleGap(allParas[s], oColor, curSwatch);
					}
				}
				if (ck07) {
					var allTables = curText.tables;
					for (var t=0; t<allTables.length; t++) {
						// Konturfarbe
						replaceStrokeTable(allTables[t], oColor, curSwatch);
						var allCells = allTables[t].cells;
						// Zellen (Kontur, Hintergrund, Inhalt)
						for (var c=0; c<allCells.length; c++) {
							replaceCellStroke(allCells[c], oColor, curSwatch);
							replaceCellFill(allCells[c], oColor, curSwatch);
							replaceCellText(allCells[c], oColor, curSwatch);
						}
					}
				}
				// Schlagschatten usw.
				if (ck11) {
					replaceDrop(allFrames[f], oColor, curSwatch);
					replaceDropText(allFrames[f], oColor, curSwatch);
				}
			}
			// nicht zugewiesen
			else if (curCont == ContentType.UNASSIGNED) {
				// Linienrahmen
				if (curType == "GraphicLine") {
					if (ck06) {
						// die (unsichtbare) Fllfarbe auf "[Ohne]"
						replaceFill(allFrames[f], oColor, "None");
						// Konturfarbe
						if (ck01) {
							replaceStroke(allFrames[f], oColor, curSwatch);
						}
						// Farbe fr Lcke
						if (ck02) {
							replaceGap(allFrames[f], oColor, curSwatch);
						}
						// Schlagschatten
						if (ck11) {
							replaceDrop(allFrames[f], oColor, curSwatch);
						}
					}
				}
				else {
					if (ck03) {
						// Hintergrundfarbe
						if (ck00) {
							replaceFill(allFrames[f], oColor, curSwatch);
						}
						// Konturfarbe
						if (ck01) {
							replaceStroke(allFrames[f], oColor, curSwatch);
						}
						// Farbe fr Lcke
						if (ck02) {
							replaceGap(allFrames[f], oColor, curSwatch);
						}
						// Schlagschatten
						if (ck11) {
							replaceDrop(allFrames[f], oColor, curSwatch);
						}
					}
				}
			}
			// Bildrahmen
			else if (curCont == ContentType.GRAPHIC_TYPE) {
				if (ck03) {
					// Hintergrundfarbe
					if (ck00) {
						replaceFill(allFrames[f], oColor, curSwatch);
					}
					// Konturfarbe
					if (ck01) {
						replaceStroke(allFrames[f], oColor, curSwatch);
					}
					// Farbe fr Lcke
					if (ck02) {
						replaceGap(allFrames[f], oColor, curSwatch);
					}
					// Schlagschatten
					if (ck11) {
						replaceDrop(allFrames[f], oColor, curSwatch);
					}
				}
			}
		}
	}
}

// Hintergrundfarbe austauschen ///////////////////////////////////////////////////////////////////
function replaceFill(curFrame, oColor, curSwatch) {
	if (curFrame.fillColor.name == oColor) {
		curFrame.fillColor = curSwatch;
	}
}

// Konturfarbe austauschen ////////////////////////////////////////////////////////////////////////
function replaceStroke(curFrame, oColor, curSwatch) {
	if (curFrame.strokeColor.name == oColor) {
		curFrame.strokeColor = curSwatch;
	}
}

// Farbe fr Lcke austauschen ////////////////////////////////////////////////////////////////////
function replaceGap(curFrame, oColor, curSwatch) {
	if (curFrame.gapColor.name == oColor) {
		curFrame.gapColor = curSwatch;
	}
}

// Absatzlinie oben und unten /////////////////////////////////////////////////////////////////////
function replaceRule(curFrame, oColor, curSwatch) {
	if (curFrame.ruleAboveColor.name == oColor) {
		curFrame.ruleAboveColor = curSwatch;
	}
	if (curFrame.ruleBelowColor.name == oColor) {
		curFrame.ruleBelowColor = curSwatch;
	}
}

// Absatzlinien-Lcke oben und unten //////////////////////////////////////////////////////////////
function replaceRuleGap(curFrame, oColor, curSwatch) {
	if (curFrame.ruleAboveGapColor.name == oColor) {
		curFrame.ruleAboveGapColor = curSwatch;
	}
	if (curFrame.ruleBelowGapColor.name == oColor) {
		curFrame.ruleBelowGapColor = curSwatch;
	}
}

// Tabellen-Kontur ////////////////////////////////////////////////////////////////////////////////
function replaceStrokeTable(curFrame, oColor, curSwatch) {
	if (curFrame.topBorderStrokeColor.name == oColor) {
		curFrame.topBorderStrokeColor = curSwatch;
	}
	if (curFrame.leftBorderStrokeColor.name == oColor) {
		curFrame.leftBorderStrokeColor = curSwatch;
	}
	if (curFrame.bottomBorderStrokeColor.name == oColor) {
		curFrame.bottomBorderStrokeColor = curSwatch;
	}
	if (curFrame.rightBorderStrokeColor.name == oColor) {
		curFrame.rightBorderStrokeColor = curSwatch;
	}
	if (curFrame.topBorderStrokeGapColor.name == oColor) {
		curFrame.topBorderStrokeGapColor = curSwatch;
	}
	if (curFrame.leftBorderStrokeGapColor.name == oColor) {
		curFrame.leftBorderStrokeGapColor = curSwatch;
	}
	if (curFrame.bottomBorderStrokeGapColor.name == oColor) {
		curFrame.bottomBorderStrokeGapColor = curSwatch;
	}
	if (curFrame.rightBorderStrokeGapColor.name == oColor) {
		curFrame.rightBorderStrokeGapColor = curSwatch;
	}
}

// Tabellen-Zellen-Konturen ///////////////////////////////////////////////////////////////////////
function replaceCellStroke(curCell, oColor, curSwatch) {
	if (curCell.topEdgeStrokeColor.name == oColor) {
		curCell.topEdgeStrokeColor = curSwatch;
	}
	if (curCell.leftEdgeStrokeColor.name == oColor) {
		curCell.leftEdgeStrokeColor = curSwatch;
	}
	if (curCell.bottomEdgeStrokeColor.name == oColor) {
		curCell.bottomEdgeStrokeColor = curSwatch;
	}
	if (curCell.rightEdgeStrokeColor.name == oColor) {
		curCell.rightEdgeStrokeColor = curSwatch;
	}
	if (curCell.topEdgeStrokeGapColor.name == oColor) {
		curCell.topEdgeStrokeGapColor = curSwatch;
	}
	if (curCell.leftEdgeStrokeGapColor.name == oColor) {
		curCell.leftEdgeStrokeGapColor = curSwatch;
	}
	if (curCell.bottomEdgeStrokeGapColor.name == oColor) {
		curCell.bottomEdgeStrokeGapColor = curSwatch;
	}
	if (curCell.rightEdgeStrokeGapColor.name == oColor) {
		curCell.rightEdgeStrokeGapColor = curSwatch;
	}
	if (curCell.diagonalLineStrokeColor.name == oColor) {
		curCell.diagonalLineStrokeColor = curSwatch;
	}  
	if (curCell.diagonalLineStrokeGapColor.name == oColor) {
		curCell.diagonalLineStrokeGapColor = curSwatch;
	}
}

// Tabellen-Zellen-Hintergrnde ///////////////////////////////////////////////////////////////////
function replaceCellFill(curCell, oColor, curSwatch) {
	if (curCell.fillColor.name == oColor) {
		curCell.fillColor = curSwatch;
	}
}

// Tabellen-Zellen-Inhalt /////////////////////////////////////////////////////////////////////////
function replaceCellText(curCell, oColor, curSwatch) {
	var curText = curCell.texts[0];
	var allRanges = curText.textStyleRanges;
	// eine Schleife durch die 'text style ranges'
	for (var r=0; r<allRanges.length; r++) {
		// Fllfarbe
		if (allRanges[r].fillColor.name == oColor) {
			allRanges[r].fillColor = curSwatch;
		}
		// Konturfarbe
		if (allRanges[r].strokeColor.name == oColor) {
			allRanges[r].strokeColor = curSwatch;
		}
	}
}

// Effekte (Schlagschatten usw.) //////////////////////////////////////////////////////////////////
function replaceDrop(curFrame, oColor, curSwatch) {
	// Objekt / Schlagschatten
	if (curFrame.transparencySettings.dropShadowSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.dropShadowSettings.effectColor = curSwatch;
	}
	// Flche / Schlagschatten
	if (curFrame.fillTransparencySettings.dropShadowSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.dropShadowSettings.effectColor = curSwatch;
	}
	// Kontur / Schlagschatten
	if (curFrame.strokeTransparencySettings.dropShadowSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.dropShadowSettings.effectColor = curSwatch;
	}
	// Objekt / Schatten nach innen
	if (curFrame.transparencySettings.innerShadowSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.innerShadowSettings.effectColor = curSwatch;
	}
	// Flche / Schatten nach innen
	if (curFrame.fillTransparencySettings.innerShadowSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.innerShadowSettings.effectColor = curSwatch;
	}
	// Kontur / Schatten nach innen
	if (curFrame.strokeTransparencySettings.innerShadowSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.innerShadowSettings.effectColor = curSwatch;
	}
	// Objekt / Schein nach aussen
	if (curFrame.transparencySettings.outerGlowSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.outerGlowSettings.effectColor = curSwatch;
	}
	// Flche / Schein nach aussen
	if (curFrame.fillTransparencySettings.outerGlowSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.outerGlowSettings.effectColor = curSwatch;
	}
	// Kontur / Schein nach aussen
	if (curFrame.strokeTransparencySettings.outerGlowSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.outerGlowSettings.effectColor = curSwatch;
	}
	// Objekt / Schein nach innen
	if (curFrame.transparencySettings.innerGlowSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.innerGlowSettings.effectColor = curSwatch;
	}
	// Flche / Schein nach innen
	if (curFrame.fillTransparencySettings.innerGlowSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.innerGlowSettings.effectColor = curSwatch;
	}
	// Kontur / Schein nach innen
	if (curFrame.strokeTransparencySettings.innerGlowSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.innerGlowSettings.effectColor = curSwatch;
	}
	// Objekt / Abgeflachte Kante und Relief / Lichter
	if (curFrame.transparencySettings.bevelAndEmbossSettings.highlightColor.name == oColor) {
		curFrame.transparencySettings.bevelAndEmbossSettings.highlightColor = curSwatch;
	}
	// Objekt / Abgeflachte Kante und Relief / Schatten
	if (curFrame.transparencySettings.bevelAndEmbossSettings.shadowColor.name == oColor) {
		curFrame.transparencySettings.bevelAndEmbossSettings.shadowColor = curSwatch;
	}
	// Flche / Abgeflachte Kante und Relief / Lichter
	if (curFrame.fillTransparencySettings.bevelAndEmbossSettings.highlightColor.name == oColor) {
		curFrame.fillTransparencySettings.bevelAndEmbossSettings.highlightColor = curSwatch;
	}
	// Flche / Abgeflachte Kante und Relief / Schatten
	if (curFrame.fillTransparencySettings.bevelAndEmbossSettings.shadowColor.name == oColor) {
		curFrame.fillTransparencySettings.bevelAndEmbossSettings.shadowColor = curSwatch;
	}
	// Kontur / Abgeflachte Kante und Relief / Lichter
	if (curFrame.strokeTransparencySettings.bevelAndEmbossSettings.highlightColor.name == oColor) {
		curFrame.strokeTransparencySettings.bevelAndEmbossSettings.highlightColor = curSwatch;
	}
	// Kontur / Abgeflachte Kante und Relief / Schatten
	if (curFrame.strokeTransparencySettings.bevelAndEmbossSettings.shadowColor.name == oColor) {
		curFrame.strokeTransparencySettings.bevelAndEmbossSettings.shadowColor = curSwatch;
	}
	// Objekt / Glanz
	if (curFrame.transparencySettings.satinSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.satinSettings.effectColor = curSwatch;
	}
	// Flche / Glanz
	if (curFrame.fillTransparencySettings.satinSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.satinSettings.effectColor = curSwatch;
	}
	// Kontur / Glanz
	if (curFrame.strokeTransparencySettings.satinSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.satinSettings.effectColor = curSwatch;
	}
}

// Text-Effekte (Schlagschatten usw.) //////////////////////////////////////////////////////////////////
function replaceDropText(curFrame, oColor, curSwatch) {
	if (curFrame.contentTransparencySettings.dropShadowSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.dropShadowSettings.effectColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.innerShadowSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.innerShadowSettings.effectColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.outerGlowSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.outerGlowSettings.effectColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.innerGlowSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.innerGlowSettings.effectColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.bevelAndEmbossSettings.highlightColor.name == oColor) {
		curFrame.contentTransparencySettings.bevelAndEmbossSettings.highlightColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.bevelAndEmbossSettings.shadowColor.name == oColor) {
		curFrame.contentTransparencySettings.bevelAndEmbossSettings.shadowColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.satinSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.satinSettings.effectColor = curSwatch;
	}
}